/**
 * Copyright © CENRA (2016)
 *
 * remi.clement@espaces-naturels.fr
 * 
 * This software is a multi-platform and portable application based on 
 * the scientifical toolbox to monitor wetlands. With this toolbox it’s 
 * possible to calculate indicators «RhoMéO» to monitor quality, 
 * fonctionalities and urban and agricultural pressures of wetlands. 
 * Indicators are calculated using naturalist data entered and/or imported,
 * and geographic data downloaded from a geographic server.
 * 
 * This software is governed by the CeCILL license under French law and
 * abiding by the rules of distribution of free software.  You can  use, 
 * modify and/ or redistribute the software under the terms of the CeCILL
 * license as circulated by CEA, CNRS and INRIA at the following URL
 * "http://www.cecill.info". 
 * 
 * As a counterpart to the access to the source code and  rights to copy,
 * modify and redistribute granted by the license, users are provided only
 * with a limited warranty  and the software's author,  the holder of the
 * economic rights,  and the successive licensors  have only  limited
 * liability. 
 * 
 * In this respect, the user's attention is drawn to the risks associated
 * with loading,  using,  modifying and/or developing or reproducing the
 * software by the user in light of its specific status of free software,
 * that may mean  that it is complicated to manipulate,  and  that  also
 * therefore means  that it is reserved for developers  and  experienced
 * professionals having in-depth computer knowledge. Users are therefore
 * encouraged to load and test the software's suitability as regards their
 * requirements in conditions enabling the security of their systems and/or 
 * data to be ensured and,  more generally, to use and operate it in the 
 * same conditions as regards security. 
 * 
 * The fact that you are presently reading this means that you have had
 * knowledge of the CeCILL license and that you accept its terms.
*/
package fr.cenra.rhomeo.protocol.p02.additional;

import fr.cenra.rhomeo.api.result.AdditionalValue;
import java.util.Objects;

/**
 * Contains a set of 11 values indexed from 0 to 10. It's identified by a name
 * and a year given at built.
 * Equality method considers only name and years, as they should be primary keys.
 * @author Alexis Manin (Geomatys)
 */
public class Value implements AdditionalValue {

    private final int[] values;
    private int year;
    private String name;

    public Value() {
        this(0, null);
    }

    public Value(final int year, final String name) {
        this.year = year;
        this.name = name;
        values = new int[11];
    }

    public int[] allValues() {
        return values;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public int getYear() {
        return year;
    }

    public void setYear(int year) {
        this.year = year;
    }

    public int get0() {
        return values[0];
    }

    public void set0(final int value) {
        values[0] = value;
    }

    public int get1() {
        return values[1];
    }

    public void set1(final int value) {
        values[1] = value;
    }

    public int get2() {
        return values[2];
    }

    public void set2(final int value) {
        values[2] = value;
    }

    public int get3() {
        return values[3];
    }

    public void set3(final int value) {
        values[3] = value;
    }

    public int get4() {
        return values[4];
    }

    public void set4(final int value) {
        values[4] = value;
    }

    public int get5() {
        return values[5];
    }

    public void set5(final int value) {
        values[5] = value;
    }

    public int get6() {
        return values[6];
    }

    public void set6(final int value) {
        values[6] = value;
    }

    public int get7() {
        return values[7];
    }

    public void set7(final int value) {
        values[7] = value;
    }

    public int get8() {
        return values[8];
    }

    public void set8(final int value) {
        values[8] = value;
    }

    public int get9() {
        return values[9];
    }

    public void set9(final int value) {
        values[9] = value;
    }

    public int get10() {
        return values[10];
    }

    public void set10(final int value) {
        values[10] = value;
    }

    @Override
    public int hashCode() {
        int hash = 5;
        hash = 89 * hash + this.year;
        hash = 89 * hash + Objects.hashCode(this.name);
        return hash;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        final Value other = (Value) obj;
        if (this.year != other.year)
            return false;
        if (!Objects.equals(this.name, other.name))
            return false;
        return true;
    }
}
